<?php
namespace app\model;

use think\Model;

class BpsAdsMerchantStoreRelation extends Model
{
    // 设置当前模型对应的完整数据表名称
    protected $table = 'bps.bps_ads_merchant_store_relation';

    // 设置主键
    protected $pk = 'id';
    // 复合唯一键验证
    protected $unique = [
        ['platform', 'merchant_id', 'account_id', 'store_id']
    ];

    // 设置自动时间戳
    protected $autoWriteTimestamp = true;

    // 定义时间戳字段
    protected $createTime = 'created_at';  // 创建时间字段
    protected $updateTime = 'updated_at';  // 更新时间字段

    // 字段类型映射
    // 字段类型映射（移除了不存在的字段）
    protected $casts = [
        'platform' => 'int',
    ];

    // 默认值设置
    protected $defaults = [
        // 根据实际需要设置存在的字段默认值
    ];

}