<?php
namespace app\model;

use think\Model;

class ThirdUserAdvertiser extends Model
{
    // 设置当前模型对应的完整数据表名称
    /**
     * @var ThirdUser|mixed
     */
    public mixed $user;
    protected $table = 'bps.bps_third_user_advertiser';

    // 设置主键
    protected $pk = 'id';

    // 设置自动时间戳
//    protected $autoWriteTimestamp = true;

    // 定义时间戳字段
//    protected $createTime = 'create_at';  // 创建时间字段
//    protected $updateTime = 'update_at';  // 更新时间字段

    // 字段类型映射
    protected $casts = [
        'id' => 'int',
        'doc_' => 'int', // 外键字段，指向 bps_third_user 表的 id
    ];

    // 关联第三方用户模型（广告主属于用户）
    public function googleUser()
    {
        return $this->belongsTo(ThirdUser::class, 'doc_', 'id');
    }

    // 关联广告主的其他数据模型，按需要可以增加（例如广告系列，广告组等）
    // public function campaign()
    // {
    //     return $this->hasMany(Campaign::class, 'advertiser_id', 'advertiser_id');
    // }

    // 默认值设置（例如，如果您需要广告商名称为默认值，可以在此设置）
    protected $defaults = [
        'advertiser_name' => 'google',  // 设置默认广告商名称
    ];

    // 其他自定义方法可以根据需求添加
}